#include <bits/stdc++.h>
using namespace std;
using ll = long long;

#define int ll

const int INF = (int)1e15;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n), pref(n + 1);
    vector<int> pref_mn(n + 1, INF), suff_mn(n + 1, INF);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        pref[i + 1] = pref[i] + a[i];
        pref_mn[i + 1] = min(pref_mn[i], a[i]);
    }
    for (int i = n - 1; i >= 0; i--) {
        suff_mn[i + 1] = min(suff_mn[i], a[i]);
    }
    ll ans = 0;
    for (int i = 0; i < n; i++) {
        int t = i;
        int l = i, r = n;
        while (l + 1 < r) {
            int mid = (l + r) / 2;
            if (t + n - mid >= k) {
                l = mid;
            } else {
                r = mid;
            }
        }
        ans = max(ans, pref[l + 1] - pref[i] - min(pref_mn[i], suff_mn[n - l]));
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    solve();
}